!-----------------------
! madgraph - a Feynman Diagram package by Tim Stelzer and Bill Long 
! (c) 1993
!
! Filename: writesub.f
!-----------------------
 
c       subroutine writeamp(ngraphs,nexternal,nqed,nqcd,nproc,ncolor)
c !***************************************************************************
c !     writes out the subroutines
c !***************************************************************************
c       implicit none

c ! Constants

c       include 'params.inc'
c       integer    ln   
c       parameter (ln=92 )

c ! Arguments

c       integer ngraphs,nqed,nqcd,nexternal,nproc,ncolor


c ! Local Variables

c       character*75 buff
c       character*20 name
c c      character*4 temp
c       integer i,jchar,ishift,nlength,j,k,ic,nflows
c       integer idenom,inum

c ! External
      
c       logical equal
c       integer igcf

c ! Global Variables
c       double precision               den(maxgraphs)
c       integer           neigen,nrows,jplace(maxgraphs)
c       common /to_colormat/ den,neigen,nrows,jplace

c       integer flows(0:2*maxlines,0:maxfactors,0:24,0:maxflows)
c       integer         graphcolor(0:2,0:maxflows,0:maxgraphs)
c       common/to_color/graphcolor,flows

c       integer alen(maxgraphs)
c       integer wnum(-maxlines:maxlines),wcount,wlen(maxgraphs*maxlines)
c       common/toopt/wcount,wnum,wlen,alen

c       character*15 gname
c       integer iname
c       common/to_name/iname,gname
c       character*60 proc
c       integer iproc
c       common/to_write/iproc,proc
c       integer            symfact(maxgraphs)
c       common /tosymmetry/symfact

c !-----------
c ! Begin Code
c !-----------


c       ishift = iname
c       nlength = ishift
c       if (nproc .gt. 0) then
c          open(unit=ln,file=gname(1:iname)//'.f',status='unknown')
c          write(isubfile,'($a)') gname(1:iname),'.o '
c       else
c          open(unit=ln,status='scratch')
c       endif
c       name = gname(1:iname)
c       call upper_case(name)

c       print*,'Writing function ',name(1:iname) ,
c      &     ' in file ',GNAME(1:iname)//'.f.'

c       call writesum(nproc)

c       buff = 'REAL*8 FUNCTION '
c       jchar = 17
c       buff(jchar:jchar+ishift) = name(1:iname)
c       jchar = jchar+ishift
c       ishift= 10
c       buff(jchar:jchar+ishift) = '(P,NHEL,IC)'
c       jchar =jchar+ishift
c       ishift = 4
c       write(ln,'(6x,a)') buff(1:jchar)

c ! write comments

c       write(ln,5) ' '
c       write(ln,5) 'FUNCTION GENERATED BY MADGRAPH'
c       write(ln,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
c       write(ln,5) 'FOR THE POINT WITH EXTERNAL LINES W(0:6,NEXTERNAL)'
c c      write(ln,5) 'FOR THE POINT IN PHASE SPACE P(0:3,N_PARTICLES)'
c       write(ln,5) ' '
c       write(ln,5) 'FOR PROCESS '//proc(1:iproc)
c       write(ln,5) ' '

c       write(ln,10) 'IMPLICIT NONE'

c ! write parameters

c       write(ln,5) ' '
c       write(ln,5) 'CONSTANTS'
c       write(ln,5) ' '

c       buff = 'INTEGER    NGRAPHS,    NEIGEN,    NEXTERNAL'
c       write(ln,10) buff(1:50)
c       buff = 'PARAMETER (NGRAPHS=????,NEIGEN=???,NEXTERNAL=?)'
c       write(buff(20:23),'(i4)') ngraphs
c       write(buff(32:34),'(i3)') neigen
c       write(buff(46:46),'(i1)') nexternal
c       write(ln,10) buff(1:50)
c       buff = 'INTEGER    NWAVEFUNCS     , NCOLOR'
c       write(ln,10) buff(1:34)
c       buff = 'PARAMETER (NWAVEFUNCS=????, NCOLOR=????) '
c       write(buff(23:26),'(i4)') WCOUNT
c       write(buff(36:39),'(i4)') NCOLOR
c c      write(buff(36:39),'(i4)') NROWS
c       write(ln,10) buff(1:41)
c       write(ln,10) 'REAL*8     ZERO'
c       write(ln,10) 'PARAMETER (ZERO=0D0)'

c ! write argument declarations

c       write(ln,5) ' '
c       write(ln,5) 'ARGUMENTS '
c       write(ln,5) ' '

c       write(ln,10) 'REAL*8 P(0:3,NEXTERNAL)'
c       write(ln,10) 'INTEGER NHEL(NEXTERNAL), IC(NEXTERNAL)'


c ! write local declarations

c       write(ln,5) ' '
c       write(ln,5) 'LOCAL VARIABLES '
c       write(ln,5) ' '

c       write(ln,10) 'INTEGER I,J'
c       write(ln,10) 'COMPLEX*16 ZTEMP'
c       write(ln,10) 'REAL*8 DENOM(NCOLOR), CF(NCOLOR,NCOLOR)'
c       write(ln,10) 'COMPLEX*16 AMP(NGRAPHS), JAMP(NCOLOR)'
c       write(ln,10) 'COMPLEX*16 W(6,NWAVEFUNCS)'
c c      write(ln,10) 'REAL*8 RMAX,IMAX'


c ! write global declarations

c       write(ln,5) ' '
c       write(ln,5) 'GLOBAL VARIABLES'
c       write(ln,5) ' '

c       write(ln,10) 'INCLUDE "coupl.inc"'
c       write(ln,10) 'INCLUDE "coupmssm.inc"'

c       write(ln,5) ' '
c       write(ln,5) 'COLOR DATA'
c       write(ln,5) ' '

c       do while (.true.)
c          read(99,'(a)',end=99) buff
c          write(ln,'(a)') buff
c       enddo
c  99   continue

c       write(ln,5) '----------'
c       write(ln,5) 'BEGIN CODE'
c       write(ln,5) '----------'
      
c       do while (.true.)
c          read(91,'(a)',end=999) buff
c          write(ln,'(a)') buff
c       enddo
c  999  continue

c       nflows=flows(0,0,0,0)

c c      write(*,*) 'Writing flows',nflows
c       do i=1,nflows
c c
c c     First determine a common denominator for these amplitudes
c c
c          idenom=1
c          inum = 999999
c          do j=1,ngraphs
c             do k=1,graphcolor(0,0,j)         !Number of terms/flows
c                if (graphcolor(0,k,j) .eq. i) then
c                   inum = min(inum,abs(graphcolor(1,k,j)))
c c                  write(*,*) i,j,k,idenom,graphcolor(2,k,j)
c                   idenom=abs(idenom*graphcolor(2,k,j)/
c      &                 igcf(idenom,graphcolor(2,k,j)))
c c                  write(*,*) i,j,k,idenom,graphcolor(2,k,j)
c                endif
c             enddo
c          enddo
c          if (idenom .ne. 1) inum=1
c          if (inum .eq. 1 .and. idenom .eq. 1) then
c             write(ln,'($a,i4,a)')    '      JAMP(',i,') = '
c             ic = 19
c          elseif (inum .ne. 1) then
c             write(ln,'($a,i4,a,i6,a)')    '      JAMP(',i,') = ',
c      &           inum,'*( '
c             ic = 28 
c          elseif (idenom .ne. 1) then
c             write(ln,'($a,i4,a)')    '      JAMP(',i,') = (',
c      &           '('
c             ic = 20 
c          endif
c          do j=1,ngraphs
c             do k=1,graphcolor(0,0,j)         !Number of terms/flows
c             if (graphcolor(0,k,j) .eq. i) then                 
c                if (ic .gt. 60) then                    
c                   write(ln,*)                          
c                   write(ln,'($a)')'     &             '
c                   ic = 19
c                endif
c                den(j)=1d0
c                den(j)=dble(graphcolor(1,k,j))/graphcolor(2,k,j)*
c      &              idenom*symfact(j)/inum
c c               write(*,*) i,j,k,idenom,graphcolor(1,k,j),
c c     &              graphcolor(2,k,j),den(j)
c c               if (equal(den(j)/den(i),1d0)) then
c                if (equal(den(j),1d0)) then
c                   write(ln,'($a,i4,a)') '+AMP(',j,')'
c                   ic = ic+10
c c               elseif (equal(den(j)/den(i),-1d0)) then
c                elseif (equal(den(j),-1d0)) then
c                   ic = ic+10
c                   write(ln,'($a,i4,a)') '-AMP(',j,')'
c c               elseif (den(j)/den(i) .gt. 0d0) then
c                elseif (den(j) .gt. 0d0) then
c                   if (ic .gt. 50) then
c                      write(ln,*)
c                      write(ln,'($a)')'     & '
c                      ic = 8
c                   endif
c                   ic = ic+22
c                   write(ln,'($a,e10.3,a,i4,a)') '+'
c      $                ,den(j),'*AMP(',j,')'
c c               elseif (den(j)/den(i) .lt. 0d0) then
c                elseif (den(j) .lt. 0d0) then
c                   if (ic .gt. 50) then
c                      write(ln,*)
c                      write(ln,'($a)')'     & '
c                      ic = 8
c                   endif
c                   ic = ic+22
c                   write(ln,'($a,e10.3,a,i4,a)') '-'
c      $                ,abs(den(j)),'*AMP(',j,')'
c c     $                 ,den(j)/den(i),'*AMP(',j,')'
c                endif
c             endif
c          enddo
c          enddo
c          if (idenom .ne. 1) then
c             write(ln,'($a,i6)') ')/',idenom 
c          elseif (inum .ne. 1) then
c             write(ln,'($a)') ')'
c          endif
c          write(ln,*)
c       enddo
c c      write(ln,10) 'RMAX = 1D-53'
c c      write(ln,10) 'IMAX = 1D-53'
c       buff(1:nlength) = name(1:nlength)
c       buff(nlength+1:nlength+8) = ' = 0.D0'
c       write(ln,10) buff(1:nlength+8)
c       write(ln,10) 'DO I = 1, NCOLOR'
c       write(ln,10) '    ZTEMP = (0.D0,0.D0)'
c       write(ln,10) '    DO J = 1, NCOLOR'
c       write(ln,10) '        ZTEMP = ZTEMP + CF(J,I)*JAMP(J)'
c c      write(ln,10) '        RMAX  = MAX(RMAX,ABS( DBLE(ZTEMP)))'
c c      write(ln,10) '        IMAX  = MAX(IMAX,ABS(DIMAG(ZTEMP)))'
c       write(ln,10) '    ENDDO'
c       buff(1:4) = '    '
c       buff(5:nlength+5) = name(1:nlength)
c       buff(nlength+6:nlength+6) = '='
c       buff(nlength+7:2*nlength+7) = name(1:nlength)
c       buff(2*nlength+7:2*nlength+40)='+ZTEMP*DCONJG(JAMP(I))/DENOM(I)'
c       write(ln,10) buff(1:2*nlength+40)

c       buff= '    ZERROR = DCMPLX(ABS(ZTEMP)/RMAX,ABS(ZTEMP)/IMAX)'
c c      write(ln,10) buff(1:52)
c c      write(ln,10) '    IF (DBLE(ZERROR) .LT. -1D-9) THEN'
c       buff(1:15) = '        PRINT*,'
c       buff(16:16) = char(39)
c       buff(17:47) ='WARNING LARGE CANCELLATIONS IN '
c       buff(48:48+nlength) = name(1:nlength)//char(39)
c c      write(ln,10) buff(1:48+nlength)
c       buff(1:15) = '        PRINT*,'
c       buff(16:16) = char(39)
c       buff(17:37) ='Number of digits lost '
c       buff(38:38) = char(39)
c       buff(39:64) = ',INT(-LOG10(DBLE(ZERROR)))'
c c      write(ln,10) buff(1:64)
c c      write(ln,10) '    ENDIF'

c c      write(ln,10) '    IF (DIMAG(ZERROR) .LT. -1D-9) THEN'
c       buff(1:15) = '       PRINT*,'
c       buff(16:16) = char(39)
c       buff(17:47) ='WARNING LARGE CANCELLATIONS IN '
c       buff(48:48+nlength) = name(1:nlength)//char(39)
c c      write(ln,10) buff(1:48+nlength)
c       buff(1:14) = '       PRINT*,'
c       buff(15:15) = char(39)
c       buff(16:36) ='Number of digits lost '
c       buff(37:37) = char(39)
c       buff(38:64) = ',INT(-LOG10(DIMAG(ZERROR)))'
c c      write(ln,10) buff(1:64)
c c      write(ln,10) '    ENDIF'
      

c       write(ln,10) 'ENDDO'
c       buff(1:47)='CALL GAUGECHECK(JAMP,ZTEMP,EIGEN_VEC,EIGEN_VAL,'
c       buff(48:62)='NCOLOR,NEIGEN)'
c       write(ln,15) buff(1:62)
c       write(ln,10) 'END'

c       close(ln)

c  5    format('C ',A)
c  10   format(6X,A)
c  15   format('C',6X,A)
c  20   format(', P',I1)
c  30   format(',P',I1,'(0:3)')
c       end

 
c       subroutine writesum(nproc)
c !***************************************************************************
c !     writes out the subroutine which sums over helicities and
c !     and does all crossings
c !***************************************************************************
c       implicit none

c ! Constants

c       include 'params.inc'
c c      integer    maxlines  , maxcross
c c      parameter (maxlines=8, maxcross=200)
c c      integer    max_coup
c c      parameter (max_coup=5)
c c      integer    max_particles       
c c      parameter (max_particles=2**7-1)
c c      integer    max_string
c c      parameter (max_string=120)

c ! Local Variables

c       character*75 buff,fname
c       character*20 name
c       character*4 str1
c       integer i,jchar,ishift,j,flen,nexternal,ichar,nlen,nproc
c       integer isym,jhel,initc,iden(maxcross)
c       integer nhel(maxlines,3**maxlines),step(maxlines),ihel
c       integer ncross,ipart(maxlines,maxcross),ic(maxlines,maxcross)
c       integer jline(0:4),imatch(0:maxcross)
c       integer icross,iboson
c       logical found
c       integer nwp,nwm,nz,ngot

c ! Global Variables

c       integer        iline(-maxlines:maxlines),idir(-maxlines:maxlines)
c       integer        this_coup(max_coup) ,goal_coup(max_coup)
c       common/to_proc/iline,idir,this_coup,goal_coup

c       character*15 gname
c       integer iname
c       common/to_name/iname,gname
c       integer         nincoming
c       common/to_proc2/nincoming
c       character*60 proc
c       integer iproc
c       common/to_write/iproc,proc

c       integer info_p(5,max_particles),iposx(3,max_particles)
c       character*(max_string) iwave(max_particles),owave(max_particles)
c       character*(8) str(3,max_particles)
c       common/to_external/iwave,owave,iposx,info_p,str

c       character*(4*max_particles) particle(4)
c       integer                               charge_c(max_particles)
c       integer iparticle(0:max_particles,0:4),inverse(max_particles)
c       common/to_model/iparticle,  particle,  inverse, charge_c

c       logical         lwp,lwm,lz,decay,cross
c       common/to_decay/lwp,lwm,lz,decay,cross

c !-----------
c ! Begin Code
c !-----------
c c
c c     These lines for artificial decay
c c
c       if (decay) then
c          call getparticle('w+',nwp,ngot)
c          if (ngot .ne. 1) print*,'Error finding W+',nwp,ngot
c          call getparticle('w-',nwm,ngot)
c          if (ngot .ne. 1) print*,'Error finding W+',nwp,ngot
c          call getparticle('z',nz,ngot)
c          if (ngot .ne. 1) print*,'Error finding W+',nwp,ngot
c          lwp=.false.
c          lwm=.false.
c          lz =.false.
c          if (iline(iline(0)) .eq. nwp) lwp=.true.
c          if (iline(iline(0)) .eq. nwm) lwm=.true.
c          if (iline(iline(0)) .eq. nz ) lz =.true.
c          if (lz) then
c             call getparticle('e+e-',jline(1),jline(0))
c          elseif(lwp) then
c             call getparticle('e+ve',jline(1),jline(0))
c          elseif(lwm) then
c             call getparticle('ve~e-',jline(1),jline(0))
c          else
c             print*,'Warning last particle not Z or W+ or W-'
c             print*,'Not decaying'
c             decay=.false.
c          endif
c       endif
c       if (decay) then
c          iboson=iline(iline(0))
c          iline(0)=iline(0)+1
c          iline(iline(0)-1)=jline(1)
c          iline(iline(0))=jline(2)
c c         print*,'We have decay',decay,lz
c       else
c c         print*,'No decay'
c       endif

c       if (cross) then
c          call crossing(ncross,ipart,imatch)
c       else
c          ncross=1
c          imatch(0) =1
c          imatch(1) =1
c          do i=1,iline(0)
c             ipart(i,1)=i
c          enddo
c       endif
c c
c c set up all the different crossings which are not identical
c c
c       icross = 0
c       do i=1,ncross
c          if (imatch(i) .gt. icross) then
c             call getdenom(isym,initc,jhel,step,ipart(1,i))
c             iden(imatch(i)) = isym*initc*jhel
c c            write(*,*) 'iden',i,imatch(i),iden(imatch(i))
c             if (imatch(i) .ne. icross+1) then
c                print*,'Error in imatch writesub.f',i,imatch(i),icross+1
c             endif
c             icross=imatch(i)
c          endif
c       enddo
c       if (icross .ne. imatch(0)) then
c          print*,'Warning icross .ne. imatch(0)',icross,imatch(0)
c       endif
c c      write(*,*) 'iden(1)',iden(1)

c       ishift = iname
c c      nlength = ishift

c       name = gname(1:iname)
c       call upper_case(name)
c       nexternal = iline(0)
c       call sethel(nhel,step,nexternal,ihel)

c c      buff = 'REAL*8 FUNCTION S'
c c      jchar = 18
c       buff = 'SUBROUTINE S'
c       jchar = 13
c       buff(jchar:jchar+ishift) = name(1:iname)
c       jchar = jchar+ishift
c       ishift= 7
c       buff(jchar:jchar+ishift) = '(P1,ANS)'
c       jchar =jchar+ishift
c       write(92,10) buff(1:jchar)

c       call genparton(ncross,ipart,buff(12:jchar),nproc,imatch)

c       jchar=jchar-4
c       FNAME= buff(13:jchar)
c c      FNAME(JCHAR-12:JCHAR-12+13)=',NHEL(1,IHEL))'
c       FNAME(JCHAR-12:JCHAR-12+19)=',NHEL(1,IHEL),JC(1))'
c       FLEN = jchar+19

c ! write comments

c       write(92,5) ' '
c       write(92,5) 'FUNCTION GENERATED BY MADGRAPH'
c       write(92,5) 'RETURNS AMPLITUDE SQUARED SUMMED/AVG OVER COLORS'
c       write(92,5) 'AND HELICITIES'
c       write(92,5) 'FOR THE POINT IN PHASE SPACE P(0:3,NEXTERNAL)'
c       write(92,5) ' '
c       write(92,5) 'FOR PROCESS '//proc(1:iproc)
c       write(92,5) ' '
c       do i=1,ncross
c          buff = 'Crossing ??? is '
c          write(buff(10:12),'(i3)') imatch(i)
c          ichar = 17
c          do j=1,2
c             call part_string(inverse(iline(ipart(j,i))),str1,nlen)
c             buff(ichar:ichar+nlen-1) = str1(1:nlen)
c             ichar=ichar+nlen
c             buff(ichar:ichar)=' '
c             ichar=ichar+1
c          enddo
c          buff(ichar:ichar+3) = '-> '
c          ichar=ichar+3
c          do j=3,iline(0)
c             call part_string(iline(ipart(j,i)),str1,nlen)
c             buff(ichar:ichar+nlen-1) = str1(1:nlen)
c             ichar=ichar+nlen
c             buff(ichar:ichar)=' '
c             ichar=ichar+1
c          enddo
c          write(92,5) buff(1:ichar)
c       enddo

c       write(92,10) 'IMPLICIT NONE'

c ! write parameters

c       write(92,5) ' '
c       write(92,5) 'CONSTANTS'
c       write(92,5) ' '
c       buff = 'INTEGER    NEXTERNAL,   NCOMB,     NCROSS'
c       write(92,10) buff(1:50)
c       buff = 'PARAMETER (NEXTERNAL=?, NCOMB=???, NCROSS=???)'
c       write(buff(22:22),'(i1)') nexternal
c       write(buff(31:33),'(i3)') ihel
c c      write(buff(43:45),'(i3)') ncross
c       write(buff(43:45),'(i3)') icross
c       write(92,10) buff(1:46)
c       write(92,10) 'INTEGER    THEL'
c       write(92,10) 'PARAMETER (THEL=NCOMB*NCROSS)'

c       write(92,5) ' '
c       write(92,5) 'ARGUMENTS '
c       write(92,5) ' '
c       write(92,10) 'REAL*8 P1(0:3,NEXTERNAL),ANS(NCROSS)'

c       write(92,5) ' '
c       write(92,5) 'LOCAL VARIABLES '
c       write(92,5) ' '
c       write(92,10) 'INTEGER NHEL(NEXTERNAL,NCOMB),NTRY'
c       write(92,10) 'REAL*8 T, P(0:3,NEXTERNAL)'
c       buff = 'REAL*8 '
c       buff(8:7+iname)=name(1:iname)
c       write(92,10) buff(1:7+iname)
c       write(92,10) 'INTEGER IHEL,IDEN(NCROSS),IC(NEXTERNAL,NCROSS)'
c       write(92,10) 'INTEGER IPROC,JC(NEXTERNAL)'
c       write(92,10) 'LOGICAL GOODHEL(NCOMB,NCROSS)'
c       write(92,10) 'DATA GOODHEL/THEL*.FALSE./'
c       write(92,10) 'DATA NTRY/0/'
c       BUFF = 'DATA (NHEL(IHEL,???),IHEL=1,?) /'
c       write(buff(29:29),'(i1)') nexternal
c       do i=1,ihel
c          write(buff(17:19),'(i3)') i
c          jchar=33
c          ishift = 4
c          do j=1,nexternal
c             write(buff(jchar:jchar+ishift),'(I3,a)') nhel(j,i),','
c             jchar=jchar+ishift
c          enddo
c          jchar=jchar-1
c          write(buff(jchar:jchar),'(a1)') '/'
c          write(92,10) buff(1:jchar)
c       enddo
c       BUFF = 'DATA (  IC(IHEL,???),IHEL=1,?) /'
c       write(buff(29:29),'(i1)') nexternal
c       icross=0
c       do i=1,ncross
c          if (imatch(i) .gt. icross) then
c             write(buff(17:19),'(i3)') imatch(i)
c             jchar=33
c             ishift = 4
c             do j=1,nexternal
c c            write(buff(jchar:jchar+ishift),'(I3,a)') ic(j,i),','
c             write(buff(jchar:jchar+ishift),'(I3,a)') ipart(j,i),','
c             jchar=jchar+ishift
c             enddo
c             jchar=jchar-1
c             write(buff(jchar:jchar),'(a1)') '/'
c             write(92,10) buff(1:jchar)
c             icross=icross+1
c          endif
c       enddo
c       BUFF = 'DATA (IDEN(IHEL),IHEL=???,???) /'
c       do i=1,icross-4,4
c c      do i=1,ncross-4,4
c          write(buff(23:25),'(i3)') i
c          write(buff(27:29),'(i3)') i+3
c          jchar=33
c          ishift = 5
c          do j=0,3
c             write(buff(jchar:jchar+ishift),'(I4,a)') iden(j+i),','
c             jchar=jchar+ishift
c          enddo
c          jchar=jchar-1
c          write(buff(jchar:jchar),'(a1)') '/'
c          write(92,10) buff(1:jchar)
c       enddo
c       write(buff(23:25),'(i3)') i
c       write(buff(27:29),'(i3)') icross
c c      write(buff(27:29),'(i3)') ncross
c       jchar=33
c       ishift = 5
c       do j=0,icross-i
c c      do j=0,ncross-i
c          write(buff(jchar:jchar+ishift),'(I4,a)') iden(j+i),','
c          jchar=jchar+ishift
c       enddo
c       jchar=jchar-1
c       write(buff(jchar:jchar),'(a1)') '/'
c c      if (i .le. ncross) then
c       if (i .le. icross) then
c          write(92,10) buff(1:jchar)
c       endif
      
c       write(92,5) '----------'
c       write(92,5) 'BEGIN CODE'
c       write(92,5) '----------'
c c      buff(1:1)='S'
c c      buff(2:iname+1) = name(1:iname)
c c      buff(iname+2:iname+7) = ' = 0d0'
c c      write(92,10) buff(1:iname+7)
c       write(92,10) 'NTRY=NTRY+1'
c       write(92,10) 'DO IPROC=1,NCROSS'
c       write(92,10) 'CALL SWITCHMOM(P1,P,IC(1,IPROC),JC,NEXTERNAL)'
c c
c c     Carefull here, if there are no crossings then we don't want
c c     to flip the signs of the incoming particles because they already
c c     are flipped
c c
c       if (nincoming .gt. 0) then
c          write(92,10) 'DO IHEL=1,NEXTERNAL'
c          write(92,10) '   JC(IHEL) = +1'
c          write(92,10) 'ENDDO'
c       endif
c       WRITE(92,10) 'ANS(IPROC) = 0D0'
c       write(92,10) 'DO IHEL=1,NCOMB'
c       write(92,10) '    IF (GOODHEL(IHEL,IPROC) .OR. NTRY .LT. 2) THEN'
c       buff(1:8) = '        '
c       buff(8:9)= 'T='
c       i=33
c       buff(10:10+flen-i) = fname(1:flen-i)  
c       buff(10+flen-i+1:10+flen-1) = fname(flen-i+2:flen)
c       write(92,10) buff(1:10+flen-1)
c c      print*,buff(1:10+flen-1)
c       write(92,10) '       ANS(IPROC)=ANS(IPROC)+T'
c       buff = '        IF (T .GT. 0D0 .AND. .NOT. '
c       buff(36:) ='GOODHEL(IHEL,IPROC)) THEN'
c       write(92,10) buff(1:60)
c       write(92,10) '            GOODHEL(IHEL,IPROC)=.TRUE.'
c       write(92,5) '            WRITE(*,*) IHEL,T'
c       write(92,10) '        ENDIF'
c       write(92,10) '    ENDIF'
c       write(92,10) 'ENDDO'
c       buff(1:1) = 'S'
c       write(92,10) 'ANS(IPROC)=ANS(IPROC)/DBLE(IDEN(IPROC))'
c       write(92,10) 'ENDDO'
c       write(92,10) 'END'
c       write(92,10) ' '
c       write(92,10) ' '
c c
c c     Now if a decay was made, replace decayed particle in iline
c c
c       if (decay) then
c          iline(0)=iline(0)-1
c          iline(iline(0)) = iboson
c       endif
c  5    format('C ',A)
c  10   format(6X,A)
c  15   format('C',6X,A)
c  20   format(', P',I1)
c  30   format(',P',I1,'(0:3)')
c       end


c       subroutine writesub_f90(ngraphs,nexternal,nqed,nqcd)
c !***************************************************************************
c !     writes out the subroutine for Fortran 90 
c !***************************************************************************
c       implicit none

c ! Constants


c ! Arguments

c       integer ngraphs,nqed,nqcd,nexternal

c ! Local Variables


c !-----------
c ! Begin Code
c !-----------
c       end


c       subroutine writesum_f90
c !***************************************************************************
c !     writes out the subroutine - f90 version
c !***************************************************************************
c       implicit none

c       end

      
      subroutine sethel(nhel,step,npart,ihel)
c************************************************************************
c     Sets up all possible helicity combinations in nhel(ipart,ihel)
c     given the number of particles, and the step size to be used
c     for each particle
c     The first state is always -1, the next is 0 or 1 depending onstep
c************************************************************************
      implicit none

!     Constants
      
      include 'params.inc'

!     Arguments
      
      integer nhel(maxlines,3**maxlines),step(maxlines),npart,ihel

!     Local

      integer ipart,iflip
      logical gotone

      ihel=1
      do ipart=1,npart
         nhel(ipart,ihel)=-1
      enddo
      gotone=.true.
      do while (gotone)
c         write(*,'(8I4)'),ihel,(nhel(ipart,ihel),ipart=1,npart)
         ihel=ihel+1
         do ipart=1,npart
            nhel(ipart,ihel)=nhel(ipart,ihel-1)
         enddo
         gotone = .false.
         iflip = npart
         do while(.not. gotone .and. iflip .gt. 0)
            nhel(iflip,ihel) = nhel(iflip,ihel)+step(iflip)
            if (nhel(iflip,ihel) .gt. 1) then
               nhel(iflip,ihel) = -1
               iflip =iflip-1
            else
               gotone=.true.
            endif
         enddo
      enddo
      ihel=ihel-1
      end


!-------------------------------------
      subroutine lower_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
c      parameter (char_a = ichar('A'), char_z = ichar('Z'))
      integer    lcshift
c      parameter (lcshift = ichar('a') - ichar('A'))


! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      char_a = ichar('A')
      char_z = ichar('Z')
      lcshift = ichar('a')-ichar('A')
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+lcshift)
         end if
      end do
      end

!-------------------------------------
      subroutine upper_case(string)
      implicit none

! Constants

      integer    char_a,              char_z
c      parameter (char_a = ichar('a'), char_z = ichar('z'))
      integer    ucshift
c      parameter (ucshift = ichar('A') - ichar('a'))

! Argument

      character*(*) string

! Local Variable

      integer i

!-----------
! Begin Code
!-----------
      char_A = ichar('a')
      char_Z = ichar('z')
      ucshift = ichar('A')-ichar('a')
c      write(*,*) string
      do i=1,len(string)
         if (ichar(string(i:i)) .ge. char_a .and.
     &       ichar(string(i:i)) .le. char_z) then
            string(i:i)=char(ichar(string(i:i))+ucshift)
         end if
      end do
c      write(*,*) string
      end


      subroutine writebuff2(buff,lun)

      implicit none

! Arguments

      character*(*) buff
      integer lun

! Local Variables

      integer length,i

!-----------
! Begin Code
!-----------
      length = len(buff)
      if (length .le. 60) then
         write (lun,100) buff
      else
         i = 60
         do while (buff(i:i) .ne. '+' .and. buff(i:i).ne.'-')
            i = i - 1
         end do
         if (length-i .gt. 60) then
            print*,'Sorry buff too long in writebuff2',length,i
            print*,buff(:i)
            print*,buff(i:i+60)
            print*,buff(i+60:)
         endif
         write (lun,100) buff(:i)
         write (lun,200) buff(i+1:)
      end if
 100  format ('      ',a)
 200  format ('     &     ',a)
      end

      
